//
//																	
//	ExifStamp														
//		t@C̃^CX^v Exif Be					
//																	
//

#include <vcl.h>
#pragma hdrstop
#include <tchar.h>
#include <memory>
#include <System.StrUtils.hpp>
#include <System.IOUtils.hpp>
#include "usr_str.h"
#include "usr_exif.h"
#include "Unit1.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TExifStampForm *ExifStampForm;

//---------------------------------------------------------------------------
// TExifStampForm NX
//---------------------------------------------------------------------------
__fastcall TExifStampForm::TExifStampForm(TComponent* Owner)
    : TForm(Owner)
{
}

//---------------------------------------------------------------------------
void __fastcall TExifStampForm::FormCreate(TObject *Sender)
{
	IniFile = new TIniFile(ChangeFileExt(Application->ExeName, ".INI"));

	ImgFileList = new TStringList();
	ListBoxBuff = new TStringList();

	ImgSrcDir = ExtractFilePath(Application->ExeName);
	Working = Finished  = false;

	::DragAcceptFiles(Handle,true);
}
//---------------------------------------------------------------------------
void __fastcall TExifStampForm::FormShow(TObject *Sender)
{
	UnicodeString sct = "General";
	Left   = IniFile->ReadInteger(sct,"WinLeft",	100);
	Top    = IniFile->ReadInteger(sct,"WinTop",		100);
	Width  = IniFile->ReadInteger(sct,"WinWidth",	400);
	Height = IniFile->ReadInteger(sct,"WinHeight",	400);

	UnicodeString verstr;
	unsigned mj, mi, bl;
	if (GetProductVersion(Application->ExeName, mj, mi, bl)) {
		verstr.sprintf(_T(" V%u.%u%u"), mj, mi, bl);
	}
	Caption = Application->Title + verstr;

	ImgSrcDir = IniFile->ReadString(sct, "ImgSrcDir", ExtractFilePath(Application->ExeName));
	OptSubCheckBox->Checked = IniFile->ReadBool(sct, "OptSubDir", false);
	OptLogCheckBox->Checked = IniFile->ReadBool(sct, "OptLog", false);
	StatusBar1->SimpleText	= "ΏۃfBNg܂̓t@Cw肵Ă (hbv)";

	sct = "Option";
	FextEdit->Text = IniFile->ReadString(sct, "FileExt", ".jpg");

	FileListBox->ItemHeight = abs(FileListBox->Font->Height) * 3 / 2;
}
//---------------------------------------------------------------------------
void __fastcall TExifStampForm::FormClose(TObject *Sender,
      TCloseAction &Action)
{
	UnicodeString sct = "General";
	IniFile->WriteInteger(sct, "WinLeft",	Left);
	IniFile->WriteInteger(sct, "WinTop",	Top);
	IniFile->WriteInteger(sct, "WinWidth", 	Width);
	IniFile->WriteInteger(sct, "WinHeight",	Height);
	IniFile->WriteString( sct, "ImgSrcDir",	ImgSrcDir);
	IniFile->WriteBool(   sct, "OptSubDir",	OptSubCheckBox->Checked);
	IniFile->WriteBool(   sct, "OptLog",	OptLogCheckBox->Checked);

	sct = "Option";
	IniFile->WriteString( sct, "FileExt",	FextEdit->Text);
}
//---------------------------------------------------------------------------
void __fastcall TExifStampForm::FormDestroy(TObject *Sender)
{
	delete ImgFileList;
	delete ListBoxBuff;
	delete IniFile;
}

//---------------------------------------------------------------------------
void __fastcall TExifStampForm::FormResize(TObject *Sender)
{
	FileListBox->Invalidate();
}

//---------------------------------------------------------------------
//t@C̃hbv
//---------------------------------------------------------------------
void __fastcall TExifStampForm::WMDropFiles(TWMDropFiles &Msg)
{
	int fcount = (int)::DragQueryFile((HDROP)Msg.Drop, 0xFFFFFFFF, NULL, 0);

	if (fcount>0) {
		Screen->Cursor = crHourGlass;
		OpPanel->Enabled = false;
		std::unique_ptr<TStringList> tmplst(new TStringList());
		for(int i=0;i<fcount;i++) {
			_TCHAR dnam[MAX_PATH];
			::DragQueryFile((HDROP)Msg.Drop,i, dnam, MAX_PATH);
			if ((faDirectory & FileGetAttr(dnam)) != 0) {
				StatusBar1->SimpleText = "t@C..."; StatusBar1->Repaint();
				get_Files(dnam, tmplst.get());
				StatusBar1->SimpleText = EmptyStr; StatusBar1->Repaint();
			}
			else
				tmplst->Add(dnam);
		}

		if (Finished) {
			ImgFileList->Clear();
			ListBoxBuff->Clear();
			FileListBox->Count = 0;
		}
		for (int i=0;i<tmplst->Count;i++) {
			UnicodeString fnam = tmplst->Strings[i];
			if (ImgFileList->IndexOf(fnam) ==-1) ImgFileList->Add(fnam);
		}
		ListBoxBuff->Assign(ImgFileList);
		FileListBox->Count = ImgFileList->Count;
		if (ImgFileList->Count>0)
			StatusBar1->SimpleText = IntToStr(ImgFileList->Count) + "̑Ώۃt@C܂";
		Finished = false;
		Screen->Cursor = crDefault;
		OpPanel->Enabled = true;
	}

	::DragFinish((HDROP)Msg.Drop);
	::SetForegroundWindow(Handle);
}

//---------------------------------------------------------------------------
//fBNg̑Ώۃt@C擾
//  pnam: fBNg
//   lst: ʂi[ TStrings
//---------------------------------------------------------------------------
void __fastcall TExifStampForm::get_Files(UnicodeString pnam, TStrings *lst)
{
	try {
		TSearchOption opt = OptSubCheckBox->Checked ? TSearchOption::soAllDirectories
													: TSearchOption::soTopDirectoryOnly;
		UnicodeString x = FextEdit->Text;
		if (x.IsEmpty()) x = ".jpg";
		remove_top_s(x, '.');
		TStringDynArray x_lst = SplitString(FextEdit->Text, ".");
		for (int i=0; i<x_lst.Length; i++) {
			if (x_lst[i].IsEmpty()) continue;
			UnicodeString mask; mask.sprintf(_T("*.%s"), x_lst[i]);
			TStringDynArray f_list = TDirectory::GetFiles(pnam, mask, opt);
			for (int j=0; j<f_list.Length; ++j) lst->Add(f_list[j]);
		}
	}
	catch (...) {
		return;
	}
}

//---------------------------------------------------------------------------
//t@CXgNA
//---------------------------------------------------------------------------
void __fastcall TExifStampForm::ClearList()
{
	ImgFileList->Clear();
	ListBoxBuff->Clear();
	FileListBox->Count = 0;
	Finished = false;
}

//---------------------------------------------------------------------------
void __fastcall TExifStampForm::FileListBoxData(TWinControl *Control, int Index, UnicodeString &Data)
{
	Data = (Index>=0 && Index<ListBoxBuff->Count)? ListBoxBuff->Strings[Index] : EmptyStr;
}

//---------------------------------------------------------------------------
//Xg{bNX̕`
//---------------------------------------------------------------------------
void __fastcall TExifStampForm::FileListBoxDrawItem(TWinControl *Control, int Index,
          TRect &Rect, TOwnerDrawState State)
{
	TListBox *lp = (TListBox*)Control;
	TCanvas  *cv = lp->Canvas;
	cv->Font->Assign(lp->Font);

	cv->Brush->Color = State.Contains(odSelected)? clHighlight : clWindow;
	cv->Font->Color  = State.Contains(odSelected)? clHighlightText : clWindowText;
	cv->FillRect(Rect);

	int xp = Rect.Left + 2;
	int yp = Rect.Top + 1;
	UnicodeString lbuf = lp->Items->Strings[Index];
	UnicodeString fnam = split_pre_tab(lbuf);

	int wd = lp->ClientWidth - 4;
	if (Working || Finished) wd -= (cv->TextWidth("9999/99/99 99:99:99") + 32);
	cv->TextOut(xp, yp, minimize_str(fnam, cv, wd));

	if (Working || Finished) {
		xp += wd + 24;
		if (lbuf.Pos("s")>0 || lbuf.Pos("s")) cv->Font->Color = clRed;
		cv->TextOut(xp, yp, lbuf);
	}
}

//---------------------------------------------------------------------------
//tH_̒ǉ
//---------------------------------------------------------------------------
void __fastcall TExifStampForm::AddDirBtnClick(TObject *Sender)
{
	if (Finished) ClearList();

	if (SelectDirectory("摜fBNgǉ", "",
		ImgSrcDir, TSelectDirExtOpts()<<sdNewUI, this))
	{
		Screen->Cursor = crHourGlass;
		OpPanel->Enabled = false;
		StatusBar1->SimpleText = "t@C...";
		std::unique_ptr<TStringList> tmplst(new TStringList());
		get_Files(ImgSrcDir, tmplst.get());
		for (int i=0;i<tmplst->Count;i++) {
			UnicodeString fnam = tmplst->Strings[i];
			if (ImgFileList->IndexOf(fnam)==-1) ImgFileList->Add(fnam);
		}
		ListBoxBuff->Assign(ImgFileList);
		FileListBox->Count = ImgFileList->Count;
		if (ImgFileList->Count>0)
			StatusBar1->SimpleText = IntToStr(ImgFileList->Count) + "̑Ώۃt@C܂";
		Screen->Cursor = crDefault;
		OpPanel->Enabled = true;
	}
}
//---------------------------------------------------------------------------
//t@C̒ǉ
//---------------------------------------------------------------------------
void __fastcall TExifStampForm::AddFileBtnClick(TObject *Sender)
{
	if (Finished) ClearList();

	OpenDialog1->Title		= "摜t@Cǉ";
	OpenDialog1->Filter 	= "|JPEGt@C(*.JPG)|*.JPG;*.JPE;*.JPEG|";
	OpenDialog1->DefaultExt = "JPG";
	OpenDialog1->FileName	= "*.JPG";
	OpenDialog1->Options << ofAllowMultiSelect;
	if (OpenDialog1->Execute()) {
		for (int i=0;i<OpenDialog1->Files->Count;i++) {
			UnicodeString fnam = OpenDialog1->Files->Strings[i];
			if (ImgFileList->IndexOf(fnam)==-1) ImgFileList->Add(fnam);
		}
		ListBoxBuff->Assign(ImgFileList);
		FileListBox->Count = ImgFileList->Count;
		StatusBar1->SimpleText = IntToStr(ImgFileList->Count) + "̑Ώۃt@C܂";
	}
}
//---------------------------------------------------------------------------
//NA
//---------------------------------------------------------------------------
void __fastcall TExifStampForm::ClrListActionExecute(TObject *Sender)
{
	ClearList();
	StatusBar1->SimpleText = "ΏۃfBNg܂̓t@Cw肵Ă (hbv)";
}
//---------------------------------------------------------------------------
void __fastcall TExifStampForm::ClrListActionUpdate(TObject *Sender)
{
	TAction *ap = (TAction*)(Sender);
	ap->Enabled = (FileListBox->Items->Count>0);
}

//---------------------------------------------------------------------------
//Jn
//---------------------------------------------------------------------------
void __fastcall TExifStampForm::StartActionExecute(TObject *Sender)
{
	if (ImgFileList->Count>0) {
		Screen->Cursor  = crHourGlass;
		Working = true;
		OpPanel->Enabled = false;

		int cnt = 0, noe = 0, err = 0;
		std::unique_ptr<TStringList> tag_lst(new TStringList());
		for (int i=0;i<ImgFileList->Count;i++) {
			FileListBox->ItemIndex = i;
			UnicodeString stt_str = "... " + IntToStr(i);
			if (err>0) stt_str += "  s=" + IntToStr(err);
			if (noe>0) stt_str += "  s=" + IntToStr(noe);
			StatusBar1->SimpleText = stt_str;
			UnicodeString fnam = ImgFileList->Strings[i];
			UnicodeString istr = fnam;

			if (EXIF_GetInf(fnam, tag_lst.get())) {
				UnicodeString tstr = tag_lst->Values["36867"];	// = Be
				if (tstr.Length()==19) {
					TDateTime dt;
					try {
						dt = TDateTime(tstr);
						if (FileSetDate(fnam, DateTimeToFileDate(dt))==0) {
							cnt++;  istr += ("\t" + tstr);
						}
						else {
							err++;  istr += ("\ts");
						}
					}
					catch (EConvertError &e) {
						noe++;  istr += "\ts";
					}
				}
			}
			ListBoxBuff->Strings[i] = istr;
			FileListBox->Invalidate();
		}

		Working  = false;
		Finished = true;

		UnicodeString rslt_str = IntToStr(cnt) + "t@C̃^CX^vݒ肵܂";
		if (err>0) rslt_str += "  s=" + IntToStr(err);
		if (noe>0) rslt_str += "  s=" + IntToStr(noe);

		if (OptLogCheckBox->Checked) {
			std::unique_ptr<TStringList> loglst(new TStringList());
			loglst->Assign(FileListBox->Items);
			loglst->Add(EmptyStr);
			loglst->Add(rslt_str);
			loglst->SaveToFile(ChangeFileExt(Application->ExeName, ".LOG"));
		}

		StatusBar1->SimpleText = rslt_str;
		Screen->Cursor = crDefault;

		Application->MessageBox(rslt_str.c_str(), _T("I"), MB_OK);
		OpPanel->Enabled = true;
	}
}
//---------------------------------------------------------------------------
void __fastcall TExifStampForm::StartActionUpdate(TObject *Sender)
{
	TAction *ap = (TAction*)(Sender);
	ap->Enabled = (!Finished && (FileListBox->Items->Count>0));
}
//---------------------------------------------------------------------------

